%%% Author: Davide Lanti.

:- dynamic(step/1).
:- consult('./utils.prolog').
:- consult('./graphs/delivery_robot_graph_acyclic.prolog').
%:- consult('./graphs/8puzzle.prolog').
%:- consult('./graphs/missionaries_cannibals.prolog').

%%
% Search strategies
%%
:- consult('strategies/dfs_selection.prolog').
% :- consult('strategies/bfs_selection.prolog').
% :-consult('strategies/lcf_selection.prolog').
% :- consult('strategies/heuristic_depth_first_selection.prolog').
% :- consult('strategies/astar_selection.prolog').

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% search(Frontier):   true if there's a path from a frontier node
%                     to Goal

% goal(N):            true is N is a goal node
% neighbors(N,NN):    true if NN is neighbors list of N
% select(Path,F0,F1): Path is the selected Path from the frontier F0
%                     F1 is the new frontier

% add_to_frontier(PathToExpand,NN,F1,F2): F2 is the new frontier created
%                                         from frontier F1 by expanding 
%                                         PathToExpand with nodes NN.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

search(F0,Res) :- select([Node|Path],F0,_), goal(Node), reverse([Node|Path],Res), write(risultato(Res)).
search(F0,Solution) :- select([Node|Path],F0,F1), % log(F0,[Node|Path],F1),
		       neighbors(Node,NN),
		       add_to_frontier([Node|Path],NN,F1,F2),
		       search(F2, Solution).
