%%%%%%%%%%%%%%%%%%%%% Davide Lanti %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
goal/1.
start/1.
arc/3.
arc/2.

%%
%% goal(S) true iff S is a goal state
%% start(S) true iff S is an initial state
%% arc(S1,S2,N) true iff there is an operator of cost N that will take
%%              us from state S1 to state S2
%% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % 

start([1,2,3,4,6,8,7,5,o]). %% search([[1,2,3,4,6,8,7,5,o]],Result).
goal([1,2,3,4,5,6,7,8,o]).

% Line 1
arc([o,B,C,D,E,F,G,H,I], [B,o,C,D,E,F,G,H,I], 1).
arc([o,B,C,D,E,F,G,H,I], [D,B,C,o,E,F,G,H,I], 1).
arc([A,o,C,D,E,F,G,H,I], [A,E,C,D,o,F,G,H,I], 1).
arc([A,B,o,D,E,F,G,H,I], [A,B,F,D,E,o,G,H,I], 1).
arc([A,B,o,D,E,F,G,H,I], [A,o,B,D,E,F,G,H,I], 1).

% Line 2
arc([A,B,C,o,E,F,G,H,I], [A,B,C,E,o,F,G,H,I], 1).
arc([A,B,C,o,E,F,G,H,I], [A,B,C,G,E,F,o,H,I], 1).
arc([A,B,C,D,o,F,G,H,I], [A,B,C,D,H,F,G,o,I], 1).
arc([A,B,C,D,E,o,G,H,I], [A,B,C,D,E,I,G,H,o], 1).
arc([A,B,C,D,E,o,G,H,I], [A,B,C,D,o,E,G,H,I], 1).

% Line 3
arc([A,B,C,D,E,F,o,H,I], [A,B,C,D,E,F,H,o,I], 1).
arc([A,B,C,D,E,F,G,o,I], [A,B,C,D,E,F,G,I,o], 1).

%% Symmetric closure
edge(N,N1,C) :- arc(N1,N,C). 
edge(N,N1,C) :- arc(N,N1,C).

neighbors(S1,NN) :- findall(N,edge(S1,N,_),NN).
cost(S1,S2,C) :- edge(S1,S2,C).

%% 
% Heuristic
%%
h(State,C) :- goal(GoalL), h1(State,GoalL,0,C).

h1([],[],Acc,Acc).
h1([X|L],[X|LG],Acc,Res) :- h1(L,LG,Acc,Res).
h1([X|L],[Y|LG],Acc,Res) :- X \= Y, Acc1 is Acc+1, h1(L,LG,Acc1,Res).
