%:- module(delivery_robot_graph, [ neighbors/2, cost/3, h/2 ]).  

%%%%% Delivery Robot %%%%%%%%%%%%%%%%%%%
goal(r123).
start(o103). % E.g., search([[o103]],R).
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Graph (Adjacency list representation)

neighbors(o103,[ts,b3,o109]).
neighbors(ts,[mail]).
neighbors(mail,[]).
neighbors(o109,[o111,o119]).
neighbors(o111,[]).
neighbors(o119,[storage,o123]).
neighbors(storage,[]).
neighbors(o123,[r123,o125]).
neighbors(o125,[]).
neighbors(b1,[c2,b2]).
neighbors(b2,[b4]).
neighbors(b3,[b1,b4]).
neighbors(b4,[o109]).
neighbors(c2,[c3,c1]).
neighbors(c1,[c3]).
neighbors(c3,[]).
neighbors(r123,[]).
cost(o103,ts,8).
cost(o103,o109,12).
cost(o109,o111,4).
cost(o119,storage,7).
cost(o123,r123,4).
cost(b1,c2,3).
cost(b2,b4,3).
cost(b3,b4,7).
cost(c2,c3,6).
cost(c1,c3,8).
cost(o103,b3,4).
cost(ts,mail,6).
cost(o109,o119,16).
cost(o119,o123,9).
cost(o123,o125,4).
cost(b1,b2,6).
cost(b3,b1,4).
cost(b4,o109,7).
cost(c2,c1,4).

arc(S1,S2) :- neighbors(S1,L),!,arc1(S1,S2,L).
arc1(_,S2,[S2|_]).
arc1(S1,S2,[_|L]) :- arc1(S1,S2,L).

%% 
% Heuristic
%%

h(mail,35).
h(o109,29).
h(o123,4).
h(b1,13).
h(b4,22).
h(c3,16).
h(ts,29).
h(o111,33).
h(o125,8).
h(b2,19).
h(c1,8).
h(storage,12).
h(o103,21).
h(o119,13).
h(r123,0).
h(b3,17).
h(c2,10).
