select(Path,[Path|NewFrontier],NewFrontier).

add_to_frontier(Path,NN,F1,F2) :-
    Path=[X|Rest],
    findall([Y,X|Rest],member(Y,NN),NewPaths),
    append(F1,NewPaths,F3),
    sort_by_f(F3,F2).

sort_by_f(Frontier,[Path|NewFrontier]) :-
    sort(Frontier,[Path|NewFrontier],f).

% Cost of a path
cost([],0).
cost([_],0).
% Paths during the search are reversed..
cost([X|[H|R]],Cost) :- cost([H|R],Cost1), cost(H,X,Cost2), Cost is Cost1 + Cost2.

last_h([],0).
last_h([X|_],H):-h(X,H).

f(Path,Cost):- cost(Path,C), last_h(Path,H), Cost is C+H.
