%%
% Idea: select the path whose end is closest to a goal according to the
% heuristic function.
% Best-first search selects a path on the frontier with minimal h-value.

select(Path,[Path|NewFrontier],NewFrontier).

add_to_frontier(Path,NN,F1,F2) :-
    Path=[X|Rest],
    findall([Y,X|Rest],member(Y,NN),NewPaths),
    append(F1,NewPaths,F3),
    sort_by_h(F3,F2).

sort_by_h(Frontier,[Path|NewFrontier]) :-
    sort(Frontier,[Path|NewFrontier],h).

h([],0).
h([X|_],C) :- h(X,C).
