%% Accumulator-based reverse

reverse(L,R) :- reverse1(L,[],R).
reverse1([],R,R).
reverse1([X|L],Acc,R) :- reverse1(L,[X|Acc],R).

%% Inductive reverse (Non-tail recursive)
%reverse([],[]).
%reverse([H|L],Res) :- reverse(L,RL), append(RL,[H],Res).

sort(List,Sorted,Comparator) :- insert_sort(List,Sorted,Comparator).

insert_sort(List,Sorted,Comparator):-i_sort(List,[],Sorted,Comparator).
i_sort([],Acc,Acc,_).
i_sort([H|T],Acc,Sorted,Comparator):-insert(H,Acc,NAcc,Comparator),i_sort(T,NAcc,Sorted,Comparator).
   
insert(X,[Y|T],[Y|NT],Comparator) :- CP1=..[Comparator,X,CX], CP2=..[Comparator,Y,CY], call(CP1),call(CP2), CX>CY,insert(X,T,NT,Comparator).
insert(X,[Y|T],[X,Y|T],Comparator) :- CP1=..[Comparator,X,CX], CP2=..[Comparator,Y,CY], call(CP1), call(CP2), CX=<CY.
insert(X,[],[X],_).

:- assert(step(1)).
log(F,Path,NF) :- writeln(frontier(F)),
		  last_h(Path,Cost),
		  writeln(path(Path,h=Cost)),
		  writeln(n_frontier(NF)),
		  step(N),
		  writeln(step(N)),
		  retractall(step(_)),
		  N1 is N+1,
		  assert(step(N1)).
